//+------------------------------------------------------------------+
//|                                                   Trade_Info.mq4 |
//|                                         Copyright  2009, Xupypr |
//|                              http://www.mql4.com/ru/users/Xupypr |
//|                                               23.09.2009 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Xupypr"
#property link      "http://www.mql4.com/ru/users/Xupypr"
#property show_inputs
#include <WinUser32.mqh>

//-------------   
extern string   Only_Magics="";     //       (  )
extern string   Only_Symbols="";    //      (  )
extern string   Only_Comment="";    //       ( [sl]  [tp])
extern bool     Only_Current=false; //      
extern bool     Buys=true;          //    
extern bool     Sells=true;         //    
extern datetime Time_Begin=D'1970.01.01 00:00'; //  
extern datetime Time_End=D'2012.12.21 00:00';   //  :)

double gp=0,gl=0,lpt=0,llt=0;
string pf="0.00",ep="0.00",spw="0.00",lpw="0.00",ptt="0.00",ltt="0.00",apt="0.00",alt="0.00";
int    sp=0,lp=0,psp=0,plp=0,lsp=0,llp=0;

int start()
{
 if (!IsConnected())
 {
  MessageBox("     \t","!",MB_OK|MB_ICONERROR);
  return(-1);
 }
 if (Only_Current) Only_Symbols=Symbol();
 for (int i=0;i<OrdersHistoryTotal();i++) if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)) Select();
 for (i=0;i<OrdersTotal();i++) if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) Select();
 if (gl!=0)        pf=DoubleToStr(gp/gl,2);
 if ((sp+lp)!=0)   ep=DoubleToStr((gp-gl)/(sp+lp),2);
 if (sp!=0)        spw=DoubleToStr(100.0*psp/sp,2);
 if (lp!=0)        lpw=DoubleToStr(100.0*plp/lp,2);
 if ((sp+lp)!=0)   ptt=DoubleToStr(100.0*(psp+plp)/(sp+lp),2);
 if ((sp+lp)!=0)   ltt=DoubleToStr(100.0*(lsp+llp)/(sp+lp),2);
 if ((psp+plp)!=0) apt=DoubleToStr(gp/(psp+plp),2);
 if ((lsp+llp)!=0) alt=DoubleToStr(-gl/(lsp+llp),2);
 string str=StringConcatenate(str," : ",TimeToStr(Time_Begin)," ... ",TimeToStr(Time_End),"\n");
 if (Only_Magics!="")  str=StringConcatenate(str," : ",Only_Magics,"\n");
 if (Only_Symbols!="") str=StringConcatenate(str,": ",Only_Symbols,"\n");
 if (Only_Comment!="") str=StringConcatenate(str,": ",Only_Comment,"\n");
 if (Buys && !Sells) str=StringConcatenate(str,"   \n");
 if (!Buys && Sells) str=StringConcatenate(str,"   \n");
 str=StringConcatenate(str,"\nGross Profit:\t",DoubleToStr(gp,2),"\t\tGross Loss:\t",DoubleToStr(gl,2),"\t\tTotal Net Profit:\t",DoubleToStr(gp-gl,2),"\n",
                       "Profit Factor:\t",pf,"\t\tExpected Payoff:\t",ep,"\n\n",
                       "Total Trades:\t",sp+lp,"\t\tShort Positions:\t",sp,"\t\tLong Positions:\t",lp,"\n",
                       "\t\t\t\t(won %):\t\t(",spw,"%)\t\t(won %):\t\t(",lpw,"%)\n\n",
                       "\t\t\t\tProfit Trades:\t",psp+plp,"\t\tLoss trades:\t",lsp+llp,"\n",
                       "\t\t\t\t(% of total):\t(",ptt,"%)\t\t(% of total):\t(",ltt,"%)\n\n",
                       "Largest\t\t\t\tprofit trade:\t",DoubleToStr(lpt,2),"\t\tloss trade:\t",DoubleToStr(llt,2),"\n",
                       "Average\t\t\t\tprofit trade:\t",apt,"\t\tloss trade:\t",alt,"\t\t");
 MessageBox(str," :",MB_OK);
 return(0);
}
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
bool Select()
{
 if (OrderType()>1) return(false);
 if (Only_Magics!="" && StringFind(Only_Magics,DoubleToStr(OrderMagicNumber(),0))==-1) return(false);
 if (Only_Symbols!="" && StringFind(Only_Symbols,OrderSymbol())==-1) return(false);
 if (Only_Comment!="" && StringFind(OrderComment(),Only_Comment)==-1) return(false);
 if (!Buys && OrderType()==OP_BUY) return(false);
 if (!Sells && OrderType()==OP_SELL) return(false);
 if (OrderOpenTime()<Time_Begin || OrderOpenTime()>Time_End) return(false);
  
 double profit=OrderProfit()+OrderSwap()+OrderCommission();
 if (profit>lpt) lpt=profit;
 if (profit<llt) llt=profit;
 if (OrderType()==OP_SELL)
 {
  sp++;
  if (profit>=0)
  {
   gp+=profit;
   psp++;
  }
  else
  {
   gl-=profit;
   lsp++;
  }
 }
 if (OrderType()==OP_BUY)
 {
  lp++;
  if (profit>=0)
  {
   gp+=profit;
   plp++;
  }
  else
  {
   gl-=profit;
   llp++;
  }
 }
 return(true);
}
//+------------------------------------------------------------------+